<?php
if (!isset($_SERVER['PHP_AUTH_USER'])) {
    header("Location: ../");
    exit;
}
set_time_limit(0);
?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rel="stylesheet" href="../styles/default/css/style.css" type="text/css">
<title>meterN Updater</title>
</head>
<body>
<br>
<table width="80%" border="0" cellspacing="0" cellpadding="0" align="center">
<tr><td>
<?php
$CURDIR = dirname(dirname(__FILE__));
$SRVDIR = $_SERVER['DOCUMENT_ROOT'];
$err    = false;
$merr   = false;

define('checkaccess', TRUE);
include('../config/config_main.php');
date_default_timezone_set($DTZ);

if (!empty($_POST['bntsubmit'])) {
    $bntsubmit = $_POST['bntsubmit'];
} else {
    $bntsubmit = null;
}
if ($bntsubmit != 'Update' && $bntsubmit != 'Continue') {
    die('Error');
}
$destination = 'temp.tar.gz';

$json   = file_get_contents('http://123solar.org/metern/latest_version.php');
$data   = json_decode($json, true);
$lastv  = $data['LASTVERSION'];
$source = $data['LINK'];

if (!file_exists("$SRVDIR/_NEW/")) {
    if (!mkdir("$SRVDIR/_NEW/", 0777, true)) {
        echo "To start the procedure, log on your system and create a writable install directory named $SRVDIR/_NEW.<br><br>
		<textarea rows=3 cols=120 style='background-color:black;color: white;'>[root@plugpc ~]# mkdir -m 777 $SRVDIR/_NEW/</textarea> 
		<br><br>
		<form method='POST' action='update2.php'><input type='submit' name='bntsubmit' value='Continue'> <INPUT TYPE='button' onClick=\"location.href='admin.php'\" value='Cancel'></form>";
    }
}
if (file_exists("$SRVDIR/_NEW/") && is_writable("$SRVDIR/_NEW/")) {
    if (file_exists("$SRVDIR/_NEW/metern/scripts/version.php")) {
        include("$SRVDIR/_NEW/metern/scripts/version.php");
        $stat = stat("$SRVDIR/_NEW/metern/");
        $d    = date("d F Y H:i:s", $stat['ctime']);
        echo "An install directory already exist $SRVDIR/_NEW/ with $VERSION dated from $d.";
        if ($VERSION == $lastv) {
            $err = true;
            echo "<br>Please, finish that preinstallation.";
        } else {
            $err = true;
            echo "<br>Please, remove this directory to allow further updates.";
        }
    } else {
        // Functions
        function progress()
        {
            echo '.';
            ob_flush();
            flush();
            usleep(500); // some effects
        }
        
        function xcopy($source, $dest, $permissions)
        {
            // Check for symlinks
            if (is_link($source)) {
                return symlink(readlink($source), $dest);
            }
            // Simple copy for a file
            if (is_file($source)) {
                return copy($source, $dest);
            }
            // Make destination directory
            if (!is_dir($dest)) {
                mkdir($dest, 0755);
            }
            // Loop through the folder
            $dir = dir($source);
            while (false !== $entry = $dir->read()) {
                // Skip pointers
                if ($entry == '.' || $entry == '..') {
                    continue;
                }
                // Deep copy directories
                xcopy("$source/$entry", "$dest/$entry", $permissions);
            }
            $dir->close();
            return true;
        }
        //
        
        if (!is_writable("$SRVDIR/_NEW/")) {
            $err = true;
            echo "Error: Can't write in $SRVDIR/_NEW/";
        }
        if (file_exists("$SRVDIR/_NEW/metern/")) {
            rmdir("$SRVDIR/_NEW/metern/");
        }
        // Check free space
        $bytes     = disk_free_space(".");
        $si_prefix = array(
            'B',
            'KB',
            'MB',
            'GB',
            'TB',
            'EB',
            'ZB',
            'YB'
        );
        $base      = 1024;
        $class     = min((int) log($bytes, $base), count($si_prefix) - 1);
        
        echo '<br>Checking free space: ';
        echo sprintf('%1.2f', $bytes / pow($base, $class)) . ' ' . $si_prefix[$class];
        
        if ($bytes < 32000000) {
            $err = true;
            echo 'Error: You should have at least 32 MB left on your disk';
        } else {
            echo "\tOK<br>";
        }
        
        if (!$err) {
            // download
            ob_start();
            echo 'Downloading latest version: ';
            
            ob_flush();
            flush();
            
            $fp = fopen("$destination", 'w+');
            
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, "$source");
            //curl_setopt($ch, CURLOPT_BUFFERSIZE,128);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_PROGRESSFUNCTION, 'progress');
            curl_setopt($ch, CURLOPT_NOPROGRESS, false);
            curl_setopt($ch, CURLOPT_HEADER, 0);
            curl_setopt($ch, CURLOPT_FILE, $fp);
            curl_exec($ch);
            
            if (curl_getinfo($ch, CURLINFO_HTTP_CODE) != 200) {
                $err = true;
                echo "\t<font color='#8B0000'><b>NOK</b></font> (failed to download)";
            } else {
                echo "\tOK";
            }
            
            curl_close($ch);
            fclose($fp);
            ob_flush();
            flush();
        }
        
        if (!$err) {
            // decompress
            echo '<br>Extract : ';
            exec("tar -xzvf $destination -C $SRVDIR/_NEW/", $output, $return);
            
            // Return will return non-zero upon an error
            if (!$return) {
                echo "\tOK";
            } else {
                $err = true;
                echo 'Error while extracting';
            }
        }
        
        if (!$err) {
            echo '<br>Importing data: ';
            if (!xcopy('../data/', "$SRVDIR/_NEW/metern/data/", 0644)) {
                $merr = true;
                echo "\t<font color='#8B0000'><b>NOK</b></font> (failed to import data)";
            } else {
                echo "\tOK";
            }
            
            echo '<br>Importing config: ';
            if (!xcopy('../config/', "$SRVDIR/_NEW/metern/config/", 0644)) {
                $merr = true;
                echo "\t<font color='#8B0000'><b>NOK</b></font> (failed to import config)";
            } else {
                echo "\tOK";
            }
            
            if (!unlink("$destination")) {
                echo "<br>Cleaning: <font color='#8B0000'><b>\t<b>NOK</b></font> (can't remove $destination)";
            }
            echo '<br><hr><br>';
            if (file_exists("$SRVDIR/_NEW/metern/scripts/version.php")) {
                include("$SRVDIR/_NEW/metern/scripts/version.php");
                if (!$merr) {
                    echo "<font color='#228B22'>";
                } else {
                    echo '<b>';
                }
                echo "Latest $VERSION version has been preinstalled in $SRVDIR/_NEW/";
                if (!$merr) {
                    echo '</font>';
                } else {
                    echo " but the update didn't complete as expected !</b>";
                }
                if (!$merr) {
                    echo "<br>Stopping meterN";
                    if (file_exists('../scripts/metern.pid')) {
                        $pid     = (int) file_get_contents('../scripts/metern.pid');
                        $command = exec("kill -9 $pid > /dev/null 2>&1 &");
                        unlink('../scripts/metern.pid');
                    } else {
                        $command = exec("pkill -f metern.php > /dev/null 2>&1 &");
                    }
                }
                $d = date('Ymd');
                echo "<br><br>To complete the installation, you need to rename the old directory as a backup and move the newly created one.<br>
<img src='../images/exclamation.png' width=16 height=16 border=0> Beware: Don't use a file manager, use those commands bellow in a terminal.<br>
<textarea rows=3 cols=120 style='background-color:black;color: white;'>
[root@plugpc ~]# sudo mv $CURDIR/ $CURDIR.$d/
[root@plugpc ~]# sudo mv $SRVDIR/_NEW/metern/ $CURDIR/
</textarea>
	<br>
	<u>Side notes:</u> Previous personal modifications aren't imported (eg: styles/)
	";
            } else {
                echo "<br><br><b>Error: A directory already exist $SRVDIR/_NEW/ with a corrupt version.<br> Please, remove this directory to allow further updates</b>";
            }
        }
    }
} else {
    echo "Error: Can't write into $SRVDIR/_NEW/";
}
echo "<br><br><INPUT TYPE='button' onClick=\"location.href='admin.php'\" value='Go back to admin'>";
?>
</td></tr>
</table>
</body>
</html>
